<!doctype html>
<html lang="en">
<head>
    <title>Set Up Secure Shell Server Daemon</title>
    <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <meta http-equiv="Cache-Control" content="no-cache, no-store, must-revalidate"/>
  <link rel="shortcut icon" href="/assets/img/logo.png" type="image/png">
  <meta http-equiv="Pragma" content="no-cache"/>
  <meta http-equiv="Expires" content="0"/>
  <!-- link rel="shortcut icon" href="/assets/img/logo.png" type="image/png"-->
  <link rel="stylesheet" href="/assets/styles.css">
</head>
<body>
<header class=nav-bar>
  <nav>
    <div class=sidebar-button></div>
    <!--div id=bwtoggle></div-->
    <a class="homelink spy" href="/">r<span class=hideable>wx.gg</span></a>
    <div class="nav-right">
      <!-- div id=search-box></div -->
      <ul class=nav-links>
        <li class=nav-item><a class=nav-link href="/boost/">Boosts</a></li>
        <!--
        <li class=nav-item><a class=nav-link href="/how/">HowTos</a></li>
        <li class=nav-item><a class=nav-link href="/contrib/">Contribute</a></li>
        -->
        <li class=nav-item><a class="nav-link" href="https://gitlab.com/rwx.gg/README">GitLab</a></li>
        <li class=nav-item><a class="nav-link" href="https://www.youtube.com/rwxrob">YouTube</a></li>
        <li class=nav-item><a class="nav-link" href="https://discord.gg/9wydZXY">Discord</a></li>
        <li class=nav-item><a class="nav-link" href="https://twitch.tv/rwxrob">Twitch</a></li>
      </ul>
    </div>
  </nav>
</header>
<main id=top>
<div class=container>  <h1 id=title class=duck><a href="https://duckduckgo.com/lite?kae=t&q=Set Up Secure Shell Server Daemon">Set Up Secure Shell Server Daemon</a></h1>
  <h2 id=subtitle>Enabling Remote Connections to Your Server</h2>
  <p>You can’t do much of anything on a remote server until you can connect to it. The standard way to make such remote connections is with <code>ssh</code> but first you have to setup a secure shell server called <code>sshd</code> to which you will connect.</p>
  <div class="co-stop">
  <p>The <code>sudo</code> command is included in the following but if you are already logged in as <code>root</code> you obviously do not need to do that.</p>
  </div>
  <div class="co-fyi">
  <p>The <code>d</code> in <code>sshd</code> is for <a href="/what/daemon/">daemon</a>.</p>
  </div>
  <p>You might already have <code>sshd</code> installed. Here are a few ways to check. If you do you can skip installation.</p>
  <pre class="sh"><code>which sshd
  ls /usr/sbin/ssh*</code></pre>
  <pre class="out"><code>/usr/sbin/sshd
  /usr/sbin/sshd</code></pre>
  <h2 id="install-secure-shell-server">Install Secure Shell Server</h2>
  <p>For Linux you want the <code>openssh-server</code> package (or equivalent). As usual, you might need to update the list of packages with <code>sudo apt update</code>.</p>
  <pre class="sh"><code>sudo apt update
  sudo apt install openssh-server</code></pre>
  <h2 id="disable-password-authentication">Disable Password Authentication</h2>
  <p>You should never allow remote password login for any reason. Sometimes this is the default but always check. Open up the configuration file.</p>
  <div class="co-mind">
  <p>Don’t forget the <code>d</code> at the end of <code>sshd_config</code> because there is also a <code>ssh_config</code> file.</p>
  </div>
  <pre class="sh"><code>vi /etc/ssh/sshd_config</code></pre>
  <p>Now search for the following line to jump to it (<code>/Pass</code>)</p>
  <pre class="sshd_config"><code>#PasswordAuthentication yes</code></pre>
  <p>Uncomment that line and change it to <code>no</code>. We don’t ever want to allow password login with <code>ssh</code> because it is far too easy to defeat. We’ll use SSH keys instead.</p>
  <pre class="sshd_config"><code>PasswordAuthentication no</code></pre>
  <h2 id="add-a-public-key-to-the-root-account">Add a Public Key to the <code>root</code> Account</h2>
  <p>You might already have a <code>~/.ssh/id_25519.pub</code> key to use. If not <a href="/tools/ssh/tasks/keygen/">generate an SSH key pair</a> on the system from which you will do the connecting, your laptop or workstation.</p>
  <p>Then put that <em>public</em> key on a USB stick or even in a GitLab repo or a web page so you can get it onto your system that now has <code>openssh-server</code> installed.</p>
  <p>Now you need to <a href="/services/sshd/tasks/authpub/">authorize</a> the remote public key on your new server from the <code>root</code> account (or another one if you want to create it).</p>
  <div class="co-faq">
  <p><strong>Why Allow Root Login?</strong></p>
  <p>Allowing <code>root</code> to login <em>after</em> password login has been disabled is no where near as risky otherwise. Many cloud providers, including Digital Ocean are fine with having <code>root</code> login provided a public key has been provided and is the only means of connecting.</p>
  <p>You may still need another account to run certain services with minimal permissions. If that is the case, <em>do not give that user sudo access</em>, which defeats the purpose of lesser permissions in the first place.</p>
  </div>
  <h2 id="enable-the-secure-shell-service">Enable the Secure Shell Service</h2>
  <p>First check to see that your server has not already been enabled.</p>
  <pre class="sh"><code>sudo systemctl status sshd</code></pre>
  <p>Try one of the following to enable and activate your server.</p>
  <pre class="sh"><code>sudo systemctl enable sshd</code></pre>
  <div class="co-fyi">
  <p>This is sometimes <code>ssh</code> instead of <code>sshd</code> for some reason, even on other Ubuntu derivatives.</p>
  </div>
  <h2 id="restart-the-secure-shell-service">Restart the Secure Shell Service</h2>
  <p>If your server was already running you need to restart it. Use one of these.</p>
  <pre class="sh"><code>sudo systemctl restart sshd</code></pre>
</main>
<footer>
  <p><a href="/copyright/" id=copyright>© 2020 Rob Muhlestein. Licensed under Creative Commons Attribution-ShareAlike.</a><br/>Does something seem to have changed? <a href="/changes/">Check the change log</a>.
  <br>See something wrong? <a class="nodecor" href="https://gitlab.com/rwx.gg/README/-/issues">Open a ticket</a>.
  </p>
</footer>
<script src="/assets/main.js"></script>
</body>
</html>